(defpackage "TEST-C"
  (:use "CL" "C"))

(in-package "TEST-C")

(defconstant U+0009 (code-char #x0009))
(defconstant U+000A (code-char #x000A))
(defconstant U+000B (code-char #x000B))
(defconstant U+000C (code-char #x000C))
(defconstant U+000D (code-char #x000D))

(defmacro test-lex (string pp-token-list)
  (let ((a (gensym))
        (b (gensym))
        (c (gensym)))
    `(let ((,a ,string)
           (,b ,pp-token-list))
       (print ,a)
       (let ((,c (c:lex ,a)))
         (assert (equal ,c ,b) () "~S~%~S~%~S" ,a ,c ,b)))))

(defmacro test-condition-nil (condition &body body)
  (let ((x (gensym)))
    `(let ((,x nil))
       (handler-bind
           ((,condition #'(lambda (c)
                            (declare (ignore c))
                            (setf ,x t))))
         ,@body)
       (assert (null ,x)))))

(defmacro test-condition-t (condition &body body)
  (let ((x (gensym)))
    `(let ((,x nil))
       (handler-bind
           ((,condition #'(lambda (c)
                            (declare (ignore c))
                            (setf ,x t))))
         ,@body)
       (assert ,x))))

(defmacro test-error-t (error &body body)
  (let ((x (gensym)))
    `(let ((,x nil))
       (handler-case
           ,@body
         (,error () (setf ,x t)))
       (assert ,x))))

(defun test ()
  (test-token-lex)
  (test-trigraph)
  (test-c-comment)
  (test-c++-comment)
  (test-pp-identifier)
  (test-pp-number)
  (test-char-const)
  (test-string)
  t)

(defun test-token-lex ()
  (test-lex "" ())
  (test-lex #.(format nil "~C" U+0009) '((#\Space . 0)))
  (test-lex #.(format nil "~C" U+000B) '((#\Space . 0)))
  (test-lex #.(format nil "~C" U+000C) '((#\Space . 0)))

  (test-lex #.(format nil "~C" U+000A) '((#\Newline . 0)))
  (test-lex #.(format nil "~C" U+000D) '((#\Newline . 0)))
  (test-lex #.(format nil "~C~C" U+000D U+000A) '((#\Newline . 0)))

  (test-lex "\\" '((#\\ . 0)))
  (test-lex #.(format nil "\\~C" U+000A) ())
  (test-lex #.(format nil "\\~C" U+000D) ())
  (test-lex #.(format nil "\\~C~C" U+000D U+000A) ())

  (test-lex #.(format nil "\\~C\\~C" U+000A U+000A) ())
  (test-lex #.(format nil "\\~C\\~C" U+000A U+000D) ())
  (test-lex #.(format nil "\\~C\\~C~C" U+000A U+000D U+000A) ())

  (test-lex #.(format nil "\\~C\\~C" U+000D U+000A) ())
  (test-lex #.(format nil "\\~C\\~C" U+000D U+000D) ())
  (test-lex #.(format nil "\\~C\\~C~C" U+000D U+000D U+000A) ())

  (test-lex #.(format nil "\\~C~C\\~C" U+000D U+000A U+000A) ())
  (test-lex #.(format nil "\\~C~C\\~C" U+000D U+000A U+000D) ())
  (test-lex #.(format nil "\\~C~C\\~C~C" U+000D U+000A U+000D U+000A) ())

  (test-lex " " '((#\Space . 0)))

  (test-lex "!" '((c::! . 0)))
  (test-lex "!=" '((c::!= . 0)))

  (test-lex "#" '((c::# . 0)))
  (test-lex "##" '((c::## . 0)))

  (test-lex "%" '((c::% . 0)))
  (test-lex "%=" '((c::%= . 0)))

  (test-lex "&" '((c::& . 0)))
  (test-lex "&=" '((c::&= . 0)))
  (test-lex "&&" '((c::&& . 0)))

  (test-lex "(" '((c::|(| . 0)))
  (test-lex ")" '((c::|)| . 0)))

  (test-lex "*" '((c::* . 0)))
  (test-lex "*=" '((c::*= . 0)))

  (test-lex "+" '((c::+ . 0)))
  (test-lex "++" '((c::++ . 0)))
  (test-lex "+=" '((c::+= . 0)))

  (test-lex "," '((c::|,| . 0)))

  (test-lex "-" '((c::- . 0)))
  (test-lex "--" '((c::-- . 0)))
  (test-lex "-=" '((c::-= . 0)))
  (test-lex "->" '((c::-> . 0)))

  (test-lex "." '((c::|.| . 0)))
  (test-lex "..." '((c::|...| . 0)))

  (test-lex ":" '((c::|:| . 0)))
  (test-lex ";" '((c::|;| . 0)))

  (test-lex "<" '((c::< . 0)))
  (test-lex "<<" '((c::<< . 0)))
  (test-lex "<=" '((c::<= . 0)))
  (test-lex "<<=" '((c::<<= . 0)))

  (test-lex "=" '((c::= . 0)))
  (test-lex "==" '((c::== . 0)))

  (test-lex ">" '((c::> . 0)))
  (test-lex ">=" '((c::>= . 0)))
  (test-lex ">>" '((c::>> . 0)))
  (test-lex ">>=" '((c::>>= . 0)))

  (test-lex "?" '((c::? . 0)))
  (test-lex "[" '((c::[ . 0)))
  (test-lex "]" '((c::] . 0)))

  (test-lex "^" '((c::^ . 0)))
  (test-lex "^=" '((c::^= . 0)))

  (test-lex "{" '((c::{ . 0)))

  (test-lex "|" '((c::|\|| . 0)))
  (test-lex "|=" '((c::|\|=| . 0)))
  (test-lex "||" '((c::|\|\|| . 0)))

  (test-lex "}" '((c::} . 0)))
  (test-lex "~" '((c::~ . 0)))
  t)

(defun test-trigraph ()
  (let ((*replace-trigraphs* nil))
    (test-condition-t trigraph-lex-condition (test-lex "??!" '((c::? . 0) (c::? . 1) (c::! . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??'" '((c::? . 0) (c::? . 1) (#\' . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??(" '((c::? . 0) (c::? . 1) (c::|(| . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??)" '((c::? . 0) (c::? . 1) (c::|)| . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??-" '((c::? . 0) (c::? . 1) (c::- . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??/" '((c::? . 0) (c::? . 1) (c::/ . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??<" '((c::? . 0) (c::? . 1) (c::< . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??=" '((c::? . 0) (c::? . 1) (c::= . 2))))
    (test-condition-t trigraph-lex-condition (test-lex "??>" '((c::? . 0) (c::? . 1) (c::> . 2)))))
  (let ((*replace-trigraphs* t))
    (test-condition-t trigraph-lex-condition (test-lex "??!" '((c::|\|| . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??'" '((c::^ . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??(" '((c::[ . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??)" '((c::] . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??-" '((c::~ . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??/" '((#\\ . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??<" '((c::{ . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??=" '((c::|#| . 0))))
    (test-condition-t trigraph-lex-condition (test-lex "??>" '((c::} . 0)))))
  (let ((*replace-trigraphs* t))
    (test-condition-t trigraph-lex-condition (test-lex #.(format nil "??/~C" U+000A) ()))
    (test-condition-t trigraph-lex-condition (test-lex #.(format nil "??/~C" U+000D) ()))
    (test-condition-t trigraph-lex-condition (test-lex #.(format nil "??/~C~C" U+000D U+000A) ())))
  t)

(defun test-c-comment ()
  (test-error-t unterminated-comment-lex-error (lex "/*"))
  (test-error-t unterminated-comment-lex-error (lex "/* "))
  (test-error-t unterminated-comment-lex-error (lex "/**"))
  (test-error-t unterminated-comment-lex-error (lex "/*/"))
  (test-lex "/**/" '((#\Space . 0)))
  (test-lex "/* */" '((#\Space . 0)))
  (test-lex "/***/" '((#\Space . 0)))
  (test-lex "/*/*/" '((#\Space . 0)))
  (test-condition-nil trigraph-lex-condition (test-lex "/*??=*/" '((#\Space . 0))))
  (test-condition-t trigraph-lex-condition (test-lex "/*??=*/??=" '((#\  . 0) (c::? . 7) (c::? . 8) (c::= . 9))))
  t)

(defun test-c++-comment ()
  (test-condition-t c++-comment-lex-condition (test-lex "//" '((#\Space . 0))))
  (test-condition-nil trigraph-lex-condition (test-lex "//??!" '((#\Space . 0))))
  (test-condition-t trigraph-lex-condition (test-lex #.(format nil "//??!~C??!" U+000A) '((#\Space . 0) (#\Newline . 5) (c::? . 6) (c::? . 7) (c::! . 8))))
  t)

(defun test-pp-identifier ()
  (test-lex "a" '(((c::pp-identifier . "a") . 0)))
  (test-lex "z" '(((c::pp-identifier . "z") . 0)))
  (test-lex "A" '(((c::pp-identifier . "A") . 0)))
  (test-lex "Z" '(((c::pp-identifier . "Z") . 0)))
  (test-lex "_" '(((c::pp-identifier . "_") . 0)))

  (test-lex "a0" '(((c::pp-identifier . "a0") . 0)))
  (test-lex "a9" '(((c::pp-identifier . "a9") . 0)))

  (test-lex "a b" '(((c::pp-identifier . "a") . 0) (#\Space . 1) ((c::pp-identifier . "b") . 2)))
  t)

(defun test-pp-number ()
  (test-lex "0" '(((c::pp-number . "0") . 0)))
  (test-lex "1" '(((c::pp-number . "1") . 0)))
  (test-lex "2" '(((c::pp-number . "2") . 0)))
  (test-lex "3" '(((c::pp-number . "3") . 0)))
  (test-lex "4" '(((c::pp-number . "4") . 0)))
  (test-lex "5" '(((c::pp-number . "5") . 0)))
  (test-lex "6" '(((c::pp-number . "6") . 0)))
  (test-lex "7" '(((c::pp-number . "7") . 0)))
  (test-lex "8" '(((c::pp-number . "8") . 0)))
  (test-lex "9" '(((c::pp-number . "9") . 0)))
  (test-lex ".0" '(((c::pp-number . ".0") . 0)))
  (test-lex ".1" '(((c::pp-number . ".1") . 0)))
  (test-lex ".2" '(((c::pp-number . ".2") . 0)))
  (test-lex ".3" '(((c::pp-number . ".3") . 0)))
  (test-lex ".4" '(((c::pp-number . ".4") . 0)))
  (test-lex ".5" '(((c::pp-number . ".5") . 0)))
  (test-lex ".6" '(((c::pp-number . ".6") . 0)))
  (test-lex ".7" '(((c::pp-number . ".7") . 0)))
  (test-lex ".8" '(((c::pp-number . ".8") . 0)))
  (test-lex ".9" '(((c::pp-number . ".9") . 0)))
  (test-lex "0e+1" '(((c::pp-number . "0e+1") . 0)))
  (test-lex "0e-1" '(((c::pp-number . "0e-1") . 0)))
  (test-lex "0E+1" '(((c::pp-number . "0E+1") . 0)))
  (test-lex "0E-1" '(((c::pp-number . "0E-1") . 0)))
  (test-lex "1.42E3" '(((c::pp-number . "1.42E3") . 0)))
  t)

(defun test-char-const ()
  (test-lex "'" '((#\' . 0)))
  (test-lex "''" '((#\' . 0) (#\' . 1)))
  (test-lex "'''" '((#\' . 0) (#\' . 1) (#\' . 2)))
  (test-lex "'\\'" '((#\' . 0) (#\\ . 1) (#\' . 2)))
  (test-lex #.(format nil "'~C'" U+000A) '((#\' . 0) (#\Newline . 1) (#\' . 2)))
  (test-lex #.(format nil "'~C'" U+000D) '((#\' . 0) (#\Newline . 1) (#\' . 2)))
  (test-lex #.(format nil "'~C~C'" U+000D U+000A) '((#\' . 0) (#\Newline . 1) (#\' . 3)))
  (test-lex "'a'" '(((c::char-const . "a") . 0)))
  (test-lex "'\"'" '(((c::char-const . "\"") . 0)))
  (test-lex "'\\''" '(((c::char-const . "\\'") . 0)))
  (test-lex "'\\\"'" '(((c::char-const . "\\\"") . 0)))
  (test-lex "'\\?'" '(((c::char-const . "\\?") . 0)))
  (test-lex "'\\\\'" '(((c::char-const . "\\\\") . 0)))
  (test-lex "'\\a'" '(((c::char-const . "\\a") . 0)))
  (test-lex "'\\b'" '(((c::char-const . "\\b") . 0)))
  (test-lex "'\\f'" '(((c::char-const . "\\f") . 0)))
  (test-lex "'\\n'" '(((c::char-const . "\\n") . 0)))
  (test-lex "'\\r'" '(((c::char-const . "\\r") . 0)))
  (test-lex "'\\t'" '(((c::char-const . "\\t") . 0)))
  (test-lex "'\\v'" '(((c::char-const . "\\v") . 0)))
  (test-lex "'\\0'" '(((c::char-const . "\\0") . 0)))
  (test-lex "'\\01'" '(((c::char-const . "\\01") . 0)))
  (test-lex "'\\012'" '(((c::char-const . "\\012") . 0)))
  (test-lex "'\\8'" '((#\' . 0) (#\\ . 1) ((c::pp-number . "8") . 2) (#\' . 3)))
  (test-lex "'\\x'" '((#\' . 0) (#\\ . 1) ((c::pp-identifier . "x") . 2) (#\' . 3)))
  (test-lex "'\\xF'" '(((c::char-const . "\\xF") . 0)))
  (test-lex "'\\xF0'" '(((c::char-const . "\\xF0") . 0)))
  (test-lex "'\\xFz'" '((#\' . 0) (#\\ . 1) ((c::pp-identifier . "xFz") . 2) (#\' . 5)))
  t)

(defun test-string ()
  (test-lex "\"" '((#\" . 0)))
  (test-lex "\"\"" '(((c::string . "") . 0)))
  (test-lex "\"\"\"" '(((c::string . "") . 0) (#\" . 2)))
  (test-lex "\"\\\"" '((#\" . 0) (#\\ . 1) (#\" . 2)))
  (test-lex #.(format nil "\"~C\"" U+000A) '((#\" . 0) (#\Newline . 1) (#\" . 2)))
  (test-lex #.(format nil "\"~C\"" U+000D) '((#\" . 0) (#\Newline . 1) (#\" . 2)))
  (test-lex #.(format nil "\"~C~C\"" U+000D U+000A) '((#\" . 0) (#\Newline . 1) (#\" . 3)))
  (test-lex "\"a\"" '(((c::string . "a") . 0)))
  (test-lex "\"ab\"" '(((c::string . "ab") . 0)))
  (test-lex "\"'\"" '(((c::string . "'") . 0)))
  (test-lex "\"\\'\"" '(((c::string . "\\'") . 0)))
  (test-lex "\"\\\"\"" '(((c::string . "\\\"") . 0)))
  (test-lex "\"\\?\"" '(((c::string . "\\?") . 0)))
  (test-lex "\"\\\\\"" '(((c::string . "\\\\") . 0)))
  (test-lex "\"\\a\"" '(((c::string . "\\a") . 0)))
  (test-lex "\"\\b\"" '(((c::string . "\\b") . 0)))
  (test-lex "\"\\f\"" '(((c::string . "\\f") . 0)))
  (test-lex "\"\\n\"" '(((c::string . "\\n") . 0)))
  (test-lex "\"\\r\"" '(((c::string . "\\r") . 0)))
  (test-lex "\"\\t\"" '(((c::string . "\\t") . 0)))
  (test-lex "\"\\v\"" '(((c::string . "\\v") . 0)))
  (test-lex "\"\\0\"" '(((c::string . "\\0") . 0)))
  (test-lex "\"\\01\"" '(((c::string . "\\01") . 0)))
  (test-lex "\"\\012\"" '(((c::string . "\\012") . 0)))
  (test-lex "\"\\8\"" '((#\" . 0) (#\\ . 1) ((c::pp-number . "8") . 2) (#\" . 3)))
  (test-lex "\"\\x\"" '((#\" . 0) (#\\ . 1) ((c::pp-identifier . "x") . 2) (#\" . 3)))
  (test-lex "\"\\xF\"" '(((c::string . "\\xF") . 0)))
  (test-lex "\"\\xF0\"" '(((c::string . "\\xF0") . 0)))
  (test-lex "\"\\xFz\"" '(((c::string . "\\xFz") . 0)))
  t)
